<?php
if (version_compare(PHP_VERSION, '5', '>='))
  require_once('domxml-php4-to-php5.php'); //Load the PHP5 converter

// oai-server segedfunkciok
// hibajelentok, es a kulonfele oai verb-ekre reagalo rutinok
require("parameters_inc.php");
require("oaicommon.php");
require_once("oaidb.php");

function sortbyoai_id($a, $b) {
  if (is_numeric($a["oai_id"]) && is_numeric($b["oai_id"])) {
    if ($a["oai_id"] == $b["oai_id"]) {
      return 0;
    }
    return ($a["oai_id"] < $b["oai_id"]) ? -1 : 1;
  }
  return strcmp($a["oai_id"], $b["oai_id"]);
}

function sortbyid($a, $b) {
  if (is_numeric($a["id"]) && is_numeric($b["id"])) {
    if ($a["id"] == $b["id"]) {
      return 0;
    }
    return ($a["id"] < $b["id"]) ? -1 : 1;
  }
  return strcmp($a["id"], $b["id"]);
}

// putGeneralHeader
// az ltalnos OAI-PMH fejlc kirst vgzi ez a fggvny
function putGeneralHeader($HTTP_GET_VARS) {
  echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
  echo "<OAI-PMH xmlns=\"http://www.openarchives.org/OAI/2.0/\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.openarchives.org/OAI/2.0/ http://www.openarchives.org/OAI/2.0/OAI-PMH.xsd\">\n";
  echo "<responseDate>" . ISO8601Date() . "</responseDate>\n";
  echo "<request ";
  while (list($key, $value) = each($HTTP_GET_VARS)) {
    echo $key . "=\"" . $value . "\" ";
  }
  echo ">http://" . $_SERVER["HTTP_HOST"] . $_SERVER["PHP_SELF"] . "</request>\n";
}

function OAIXMLError($errorcode, $additional = "", $VARS = NULL) {
  if ($VARS === NULL) {
    $VARS = $_GET;
  }
  putGeneralHeader($VARS);
  echo "<error code=\"" . $errorcode . "\">" . $additional . "</error>";
  echo "</OAI-PMH>";
}

// badVerb
// rossz OAI parancs esetn az Illegal OAI verb hibazenetet adja
function badVerb($HTTP_GET_VARS = NULL) {
  OAIXMLError("badVerb", "Illegal OAI verb", $HTTP_GET_VARS);
}

// badArgument
// rossz argumentum esetn erre utal hibazenetet ad vissza.
function badArgument($HTTP_GET_VARS = NULL) {
  OAIXMLError("badArgument", "", $HTTP_GET_VARS);
}

// idDoesNotExist
// nem ltez OAI azonost esetn hibazenetet ad vissza
function idDoesNotExist($HTTP_GET_VARS) {
  OAIXMLError("idDoesNotExist", $HTTP_GET_VARS["identifier"], $HTTP_GET_VARS);
}

// cannotDisseminateFormat
// a nemltez metaadat formtum krse esetn ilyen tartalm hibazenetet ad vissza a fggvny
function cannotDisseminateFormat($HTTP_GET_VARS) {
  OAIXMLError("cannotDisseminateFormat", $HTTP_GET_VARS["metadataPrefix"], $HTTP_GET_VARS);
}

// badResumptionToken
// mivel a jelenlegi megvalsts az egy menetben trtn kommunikcit tmogatja, ezrt
// a "resumptionToken" megadsa esetn az ilyen argumentumra hibt ad vissza
function badResumptionToken($HTTP_GET_VARS) {
  OAIXMLError("badResumptionToken", "This archive does not support the resumption method.", $HTTP_GET_VARS);
}

// noRecordsMatch
// abban az esetben, ha a krsre, a megadott paramterekre vonatkozan
// nem tallhat metaadatrekord a repositoryban, akkor az ennek megfelel
// hibazenetet adja vissza
function noRecordsMatch($HTTP_GET_VARS) {
  OAIXMLError("noRecordsMatch", "No record matches the given conditions.", $HTTP_GET_VARS);
}


// identify
// az "Identify" OAI verb implementlsa
// a repository azonost adatait adja vissza a paramterekben megadottaknak megfelelen
function OAIidentify() {
  global $repository, $config;
  if (!isset($HTTP_GET_VARS)) {
    $HTTP_GET_VARS = $_GET;
  }

  if (sizeof($HTTP_GET_VARS) > 1) {
    badArgument($HTTP_GET_VARS);
  } else {
    putGeneralHeader($HTTP_GET_VARS);
    echo "<Identify><repositoryName>" . $config["repositoryName"] . "</repositoryName>";
    echo "<baseURL>http://" . $_SERVER["HTTP_HOST"] . $_SERVER["PHP_SELF"] . "</baseURL>";
    echo "<protocolVersion>2.0</protocolVersion>";
    echo "<adminEmail>" . $config["adminEmail"] . "</adminEmail>";
    echo "<earliestDatestamp>1970-01-01T00:00:00Z</earliestDatestamp>";
    echo "<deletedRecord>" . $config["deletedRecord"] . "</deletedRecord>";
    echo "<granularity>YYYY-MM-DDThh:mm:ssZ</granularity>";
    echo "<compression>deflate</compression>";

    echo "<description>";
    echo "<oai-identifier xmlns=\"http://www.openarchives.org/OAI/2.0/oai-identifier\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.openarchives.org/OAI/2.0/oai-identifier http://www.openarchives.org/OAI/2.0/oai-identifier.xsd\">";
    echo "<scheme>oai</scheme>";
    echo "<repositoryIdentifier>" . $config["repositoryId"] . "</repositoryIdentifier>";
    echo "<delimiter>:</delimiter>";
    echo "<sampleIdentifier>oai:" . $config["repositoryId"] . ":1</sampleIdentifier>";
    echo "</oai-identifier>";
    echo "</description>";

    if (count($config["friends"]) > 0) {
      echo "<description>";
      echo "<friends xmlns=\"http://www.openarchives.org/OAI/2.0/friends/\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.openarchives.org/OAI/2.0/friends/ http://www.openarchives.org/OAI/2.0/friends.xsd\">";

      foreach($config["friends"] as $key => $value) {
        echo "<baseURL>" . $value . "</baseURL>";
      }

      echo "</friends>";
      echo "</description>";
    }
    echo "</Identify>";
    echo "</OAI-PMH>";
  }
}

// getRecord
// a fggvny a "getRecord" OAI verb-et valstja meg
// a paramterknt kapott repository azonost illetve repositoryfjl neve alapjn.
// a repository llomnyt beolvassa, feldolgozza, az OAI krsben szerepl paramterek
// alapjn visszaadja a vlaszt a krdeznek.
function OAIgetRecord() {
  global $repository, $config, $metadataFormats;
  if (!isset($HTTP_GET_VARS)) {
    $HTTP_GET_VARS = $_GET;
  }

  $records = getRecordsNew($repository);

  $keys = array_keys($HTTP_GET_VARS);
  $error = 0;
  for ($i = 1; $i < count($keys); $i++) {
    switch (strtolower($keys[$i])) {
      case "identifier": //kotelezo
        $identifier = $HTTP_GET_VARS[$keys[$i]];
        //   oai:proba:1
        $parts = explode(":", $identifier);
        $identifier = $parts[2];
        break;
      case "metadataprefix": //kotelezo
        $metadataPrefix = $HTTP_GET_VARS[$keys[$i]];
        break;
      default: $error = 1;
    }
  }

  if (($error == 1) || (!isset($identifier)) || (!isset($metadataPrefix))) {
    badArgument($HTTP_GET_VARS);
    $error = 1;
  }

  if (($error == 0) && (($parts[1] != $config["repositoryId"]) || ($parts[0] != "oai") || (strlen(trim($records[$identifier])) == 0))) {
    idDoesNotExist($HTTP_GET_VARS);
    $error = 1;
  }

  $root_name = $metadataFormats[$metadataPrefix]["rootElementName"]; 
  if (($error == 0) && (strlen($root_name) > 0) && (strlen($records[$identifier][$root_name]["xml"]) == 0)) {
    cannotDisseminateFormat($HTTP_GET_VARS);
    $error = 1;
  }

  if ($error == 0) {
    putGeneralHeader($HTTP_GET_VARS);
    echo "<GetRecord><record><header><identifier>oai:" . $config["repositoryId"] . ":" . $identifier . "</identifier>";
    echo "<datestamp>" . $records[$identifier][$root_name]["created"] . "</datestamp>";
    echo (strlen($records[$identifier][$root_name]["sett"]) > 0) ? "<setSpec>" . $records[$identifier][$root_name]["sett"] . "</setSpec>" : "";
    echo "</header><metadata>";
    echo $records[$identifier][$root_name]["xml"];
    echo "</metadata></record></GetRecord>";
    echo "</OAI-PMH>";
  }
}

// listRecords
// a fggvny a "listRecords" OAI verb-et valstja meg
// a paramterknt kapott repository azonost illetve repositoryfjl neve alapjn.
// a repository llomnyt beolvassa, feldolgozza, az OAI krsben szerepl paramterek
// alapjn visszaadja a vlaszt a krdeznek.
function OAIlistRecords() {
  global $repository, $config, $metadataFormats;
  if (!isset($HTTP_GET_VARS)) {
    $HTTP_GET_VARS = $_GET;
  }

  $records = getRecordsNew($repository);
  $keys = array_keys($HTTP_GET_VARS);
  for ($i = 1; $i < count($keys); $i++) {
    switch (strtolower($keys[$i])) {
      case "from":
        $from = $HTTP_GET_VARS[$keys[$i]];
        break;
      case "until":
        $until = $HTTP_GET_VARS[$keys[$i]];
        break;
      case "metadataprefix":
        $metadataPrefix = $HTTP_GET_VARS[$keys[$i]];
        break;
      case "set":
        $set = $HTTP_GET_VARS[$keys[$i]];
        break;
      case "resumptiontoken":
        $resumptionToken = $HTTP_GET_VARS[$keys[$i]];
        break;
      default:
         badArgument($HTTP_GET_VARS);
         return FALSE;
    }
  }

  if (isset($resumptionToken)) {
    $resumptionInfo = unserialize(gzuncompress(base64_decode(rawurldecode($resumptionToken))));
    $showmin = $resumptionInfo["showmin"];
    $set = $resumptionInfo["set"];
    $from = $resumptionInfo["from"];
    $until = $resumptionInfo["until"];
    $metadataPrefix = $resumptionInfo["metadataPrefix"];
  } else {
    $showmin = 0;
  }

  if (!isset($metadataPrefix)) {
    cannotDisseminateFormat($HTTP_GET_VARS);
  } elseif (!array_key_exists($metadataPrefix, $metadataFormats)) {
    cannotDisseminateFormat($HTTP_GET_VARS);
  } elseif (sizeof($records) == 0) {
    noRecordsMatch($HTTP_GET_VARS);
  } else {
    $root_name = $metadataFormats[$metadataPrefix]["rootElementName"];
    $response = "";
    foreach($records as $kulcs => $ertek) {
      if (is_array($records[$kulcs][$root_name])) {
        if (!isset($set) || (isset($set) && ($records[$kulcs][$root_name]["sett"] == $set))) {
          if ($records[$kulcs][$root_name]["harvestable"] != "n") {
            $created = $records[$kulcs][$root_name]["created"];
            $modified = $records[$kulcs][$root_name]["modified"];
            $deleted = $records[$kulcs][$root_name]["deleted"];
            $ok = 0;

            if (isset($from) && ($from < $modified || $from < $deleted)) {
              $ok = 1;
            }
            if ((isset($until) && (($until > $modified && $modified >= $deleted) || ($until > $deleted && $deleted >= $modified)) && (!isset($from) || (isset($from) && $ok = 1))) || (!isset($until))) {
              $ok = 1;
            } else {
              $ok = 0;
            }

            # tulkepp ez kene a fentiek helyett...
            #if ((!isset($from) || ($from <= $modified) || ($from <= $deleted)) && (!isset($until) || ($modified <= $until) || ($deleted <= $until))) { }
            if ($ok == 1) {
              $jorecords[] = $records[$kulcs][$root_name];
            }
          }
        }
      }
    }
    $completeListSize = count($jorecords);
    if (is_numeric($config["resumptionSize"])) {
      $shownum = $config["resumptionSize"];
    } else {
      $shownum = $completeListSize;
      if (isset($resumptionToken)) {
        OAIXMLError("badResumptionToken", "This archive does not support the resumption method.");
        return FALSE;
      }
    }
    if ($completeListSize > 0) {
      if (! is_int($showmin) || ($showmin < 0) || $showmin >= $completeListSize) {
        OAIXMLError("badResumptionToken");
        return FALSE;
      }
      usort($jorecords, "sortbyid");
      if ($showmin + $shownum > $completeListSize) {
        $shownum = $completeListSize - $showmin;
      }
      $showmax = $showmin + $shownum;
      //foreach($jorecords as $key => $value) {
      for($i = $showmin; $i < $showmin + $shownum; $i++) {
        $value = $jorecords[$i];
        $created = $value["created"];
        $modified = $value["modified"];
        $deleted = $value["deleted"];
        $response .= "<record>";
        if ($created != $deleted) {
          $response .= "<header status=\"deleted\">";
          $response .= "<identifier>oai:" . $config["repositoryId"] . ":" . $value["id"] . "</identifier>";
          $response .= "<datestamp>" . $value["deleted"] . "</datestamp>";
          $response .= (strlen($value["sett"]) > 0) ? "<setSpec>" . $value["sett"] . "</setSpec>" : "";
          $response .= "</header>";
        } else {
          $response .= "<header>";
          $response .= "<identifier>oai:" . $config["repositoryId"] . ":" . $value["id"] . "</identifier>";
          $response .= "<datestamp>" . $value["modified"] . "</datestamp>";
          $response .= (strlen($value["sett"]) > 0) ? "<setSpec>" . $value["sett"] . "</setSpec>" : "";
          $response .= "</header>";
          $response .= "<metadata>";
          $response .= $value["xml"];
          $response .= "</metadata>";
        }
        $response .= "</record>";
      }
      if (is_numeric($config["resumptionSize"])) {
        $response .= "<resumptionToken completeListSize=\"" . $completeListSize . "\" cursor=\"" . $showmin . "\" ";
        if ($showmax != $completeListSize) {
          $response .= "expirationDate=\"" . ISO8601Date(time() + $config["resumptionExpirationHours"] * 3600) . "\">";
          $response .= base64_encode(gzcompress(serialize(array("showmin" => $showmax, "set" => $set, "from" => $from, "until" => $until, "metadataPrefix" => $metadataPrefix))));
        } else {
          $response .= ">";
        }
        $response .= "</resumptionToken>";
      }
    }
    if (strlen($response) > 0) {
      putGeneralHeader($HTTP_GET_VARS);
      echo "<ListRecords>" . $response . "</ListRecords></OAI-PMH>";
    } else {
      noRecordsMatch($HTTP_GET_VARS);
    }
  }
}


// listIdentifiers
// a fggvny a "listIdentifiers" OAI verb-et valstja meg
// a paramterknt kapott repository azonost illetve repositoryfjl neve alapjn.
// a repository llomnyt beolvassa, feldolgozza, az OAI krsben szerepl paramterek
// alapjn visszaadja a vlaszt a krdeznek.
function OAIlistIdentifiers() {
  global $repository, $config, $metadataFormats;
  if (!isset($HTTP_GET_VARS)) {
    $HTTP_GET_VARS = $_GET;
  }

  $records = getRecordsNew($repository);
  $keys = array_keys($HTTP_GET_VARS);
  for ($i = 1; $i < count($keys); $i++) {
    switch ($keys[$i]) {
      case "from":
        $from = $HTTP_GET_VARS[$keys[$i]];
        break;
      case "until":
        $until = $HTTP_GET_VARS[$keys[$i]];
        break;
      case "metadataPrefix":
        $metadataPrefix = $HTTP_GET_VARS[$keys[$i]];
        break;
      case "set":
        $set = $HTTP_GET_VARS[$keys[$i]];
        break;
      case "resumptionToken":
        $resumptionToken = $HTTP_GET_VARS[$keys[$i]];
        break;
      default:
        badArgument($HTTP_GET_VARS);
        return FALSE;
    }
  }

  if (isset($resumptionToken)) {
    $resumptionInfo = unserialize(gzuncompress(base64_decode(rawurldecode($resumptionToken))));
    $showmin = $resumptionInfo["showmin"];
    $set = $resumptionInfo["set"];
    $from = $resumptionInfo["from"];
    $until = $resumptionInfo["until"];
    $metadataPrefix = $resumptionInfo["metadataPrefix"];
  } else {
    $showmin = 0;
  }

  if (!isset($metadataPrefix)) {
    cannotDisseminateFormat($HTTP_GET_VARS);
  } elseif (!array_key_exists($metadataPrefix, $metadataFormats)) {
    cannotDisseminateFormat($HTTP_GET_VARS);
  } elseif (sizeof($records) == 0) {
    noRecordsMatch($HTTP_GET_VARS);
  } else {
    $root_name = $metadataFormats[$metadataPrefix]["rootElementName"];
    $jorecords = array();
    $response = "";
    foreach($records as $kulcs => $ertek) {
      if (is_array($records[$kulcs][$root_name])) {
        if (!isset($set) || (isset($set) && ($records[$kulcs][$root_name]["sett"] == $set))) {
          if ($records[$kulcs][$root_name]["harvestable"] != "n") {
            $created = $records[$kulcs][$root_name]["created"];
            $modified = $records[$kulcs][$root_name]["modified"];
            $deleted = $records[$kulcs][$root_name]["deleted"];
            $ok = 0;

            if (isset($from) && ($from < $modified || $from < $deleted)) {
              $ok = 1;
            }
            if ((isset($until) && (($until > $modified && $modified >= $deleted) || ($until > $deleted && $deleted >= $modified)) && (!isset($from) || (isset($from) && $ok = 1))) || (!isset($until))) {
              $ok = 1;
            } else {
              $ok = 0;
            }
            # tulkepp ez kene a fentiek helyett...
            #if ((!isset($from) || ($from <= $modified) || ($from <= $deleted)) && (!isset($until) || ($modified <= $until) || ($deleted <= $until))) { }

            if ($ok == 1) {
              $jorecords[] = $records[$kulcs][$root_name];
            }
          }
        }
      }
    }
    $completeListSize = count($jorecords);
    if (is_numeric($config["resumptionSize"])) {
      $shownum = $config["resumptionSize"];
    } else {
      $shownum = $completeListSize;
      if (isset($resumptionToken)) {
        OAIXMLError("badResumptionToken", "This archive does not support the resumption method.");
        return FALSE;
      }
    }
    if ($completeListSize > 0) {
      if (! is_int($showmin) || ($showmin < 0) || $showmin >= $completeListSize) {
        OAIXMLError("badResumptionToken");
        return FALSE;
      }
      usort($jorecords, "sortbyid");
      if ($showmin + $shownum > $completeListSize) {
        $shownum = $completeListSize - $showmin;
      }
      $showmax = $showmin + $shownum;
      //foreach($jorecords as $key => $value) {
      for($i = $showmin; $i < $showmin + $shownum; $i++) {
        $value = $jorecords[$i];
        $created = $value["created"];
        $modified = $value["modified"];
        $deleted = $value["deleted"];
        $response .= "<header>";
        if ($created != $deleted) {
          $response .= "<identifier status=\"deleted\">oai:" . $config["repositoryId"] . ":" . $value["id"] . "</identifier>";
          $response .= "<datestamp>" . $value["deleted"] . "</datestamp>";
        } else {
          $response .= "<identifier>oai:" . $config["repositoryId"] . ":" . $value["id"] . "</identifier>";
          $response .= "<datestamp>" . $value["modified"] . "</datestamp>";
        }
        $response .= (strlen($value["sett"]) > 0) ? "<setSpec>" . $value["sett"] . "</setSpec>" : "";
        $response .= "</header>";
      }
      if (is_numeric($config["resumptionSize"])) {
        $response .= "<resumptionToken completeListSize=\"" . $completeListSize . "\" cursor=\"" . $showmin . "\" ";
        if ($showmax != $completeListSize) {
          $response .= "expirationDate=\"" . ISO8601Date(time() + $config["resumptionExpirationHours"] * 3600) . "\">";
          $response .= base64_encode(gzcompress(serialize(array("showmin" => $showmax, "set" => $set, "from" => $from, "until" => $until, "metadataPrefix" => $metadataPrefix))));
        } else {
          $response .= ">";
        }
        $response .= "</resumptionToken>";
      }
    }
    if (strlen($response) > 0) {
      putGeneralHeader($HTTP_GET_VARS);
      echo "<ListIdentifiers>" . $response . "</ListIdentifiers></OAI-PMH>";
    } else {
      noRecordsMatch($HTTP_GET_VARS);
    }
  }
}

// listMetadataFormats
// a fggvny a "listMetadataFormats" OAI verb-et valstja meg
// a paramterknt kapott repository azonost illetve repositoryfjl neve alapjn.
// a repository llomnyt beolvassa, feldolgozza, az OAI krsben szerepl paramterek
// alapjn visszaadja a vlaszt a krdeznek.
function OAIlistMetadataFormats() {
  global $repository, $config, $metadataFormats, $revmetadataFormats;
  if (!isset($HTTP_GET_VARS)) {
    $HTTP_GET_VARS = $_GET;
  }

  $keys = array_keys($HTTP_GET_VARS);
  $error = 0;
  for ($i = 1; $i < count($keys); $i++) {
    switch ($keys[$i]) {
      case "identifier":
        $identifier = $HTTP_GET_VARS[$keys[$i]];
        //   oai:proba.gaan.hu:1
        $parts = explode(":", $identifier);
        $identifier = $parts[2];
        break;
      default: $error = 1;
    }
  }

  if ($error == 1) {
    badArgument($HTTP_GET_VARS);
  } else {
    if (isset($identifier)) {
      $records = getRecordsNew($repository);
      if (($parts[1] != $config["repositoryId"]) || ($parts[0] != "oai") || (strlen($records[$identifier]) == 0)) {
        idDoesNotExist($HTTP_GET_VARS);
      } else {
        putGeneralHeader($HTTP_GET_VARS);
        echo "<ListMetadataFormats>";
        foreach($records[$identifier] as $key => $value) {
        //while (list($kulcs, $ertek) = each($records[$identifier])) {
          if ($records[$identifier][$key]["created"] == $records[$identifier][$key]["deleted"]) {
            echo "<metadataFormat><metadataPrefix>" . $revmetadataFormats[$key]["format.name"] . "</metadataPrefix>";
            echo "<schema>" . $revmetadataFormats[$key]["schema"] . "</schema>";
            echo "<metadataNamespace>" . $revmetadataFormats[$key]["namespace"] . "</metadataNamespace></metadataFormat>";
          }
        }
        echo "</ListMetadataFormats>";
        echo "</OAI-PMH>";
      }
    } else {
      putGeneralHeader($HTTP_GET_VARS);
      echo "<ListMetadataFormats>";
      foreach($metadataFormats as $key => $value) {
        echo "<metadataFormat><metadataPrefix>" . $key . "</metadataPrefix>";
        echo "<schema>" . $value["schema"] . "</schema>";
        echo "<metadataNamespace>" . $value["namespace"] . "</metadataNamespace></metadataFormat>";
      }
      echo "</ListMetadataFormats>";
      echo "</OAI-PMH>";
    }
  }
}

// listSets
// a fggvny a "listSets" OAI verb-et valstja meg
// a paramterknt kapott repository azonost illetve repositoryfjl neve alapjn.
// a repository llomnyt beolvassa, feldolgozza, az OAI krsben szerepl paramterek
// alapjn visszaadja a vlaszt a krdeznek.

function OAIlistSets() {
  global $repository, $config;
  if (!isset($HTTP_GET_VARS)) {
    $HTTP_GET_VARS = $_GET;
  }

  $keys = array_keys($HTTP_GET_VARS);
  $error = 0;
  for ($i = 1; $i < count($keys); $i++) {
    switch ($keys[$i]) {
      case "resumptionToken":
        $resumptionToken = $keys[$i];
        break;
      default:
        badArgument($HTTP_GET_VARS);
        return FALSE;
    }
  }

  if (isset($resumptionToken)) {
    $resumptionInfo = unserialize(gzuncompress(base64_decode(rawurldecode($resumptionToken))));
    $showmin = $resumptionInfo["showmin"];
  } else {
    $showmin = 0;
  }
  // TODO: set kezeles: meg kell irni
  //$header = getHeaderFromCSV($repositoryfile);
  //$setek = unserialize(base64_decode($header[2]));
  $setek = NULL;

  if (isset($setek) && array_key_exists("", $setek)) {
    unset($setek[""]);
  }
  $completeListSize = count($setek);
  if (is_numeric($config["resumptionSize"])) {
    $shownum = $config["resumptionSize"];
  } else {
    $shownum = $completeListSize;
    if (isset($resumptionToken)) {
      OAIXMLError("badResumptionToken");
      return FALSE;
    }
  }

  if ($completeListSize > 0) {
    if (! is_int($showmin) || ($showmin < 0) || $showmin >= $completeListSize) {
      OAIXMLError("badResumptionToken");
      return FALSE;
    }
    //usort($jorecords, "sortbyoai_id");
    if ($showmin + $shownum > $completeListSize) {
      $shownum = $completeListSize - $showmin;
    }
    $showmax = $showmin + $shownum;

    putGeneralHeader($HTTP_GET_VARS);
    echo "<ListSets>";
    while (list($set, $tomb) = each ($setek)) {
      if (strlen($set) > 0) {
        echo "<set><setSpec>" . $set . "</setSpec>";
        if (isset($tomb[0])) { echo "<setName>" . $tomb[0] . "</setName>"; }
        if (isset($tomb[1])) { echo "<setDescription>" . $tomb[1] . "</setDescription>"; }
        echo "</set>";
      }
    }
    echo "</ListSets>";
    echo "</OAI-PMH>";
  } else {
    //if (!is_array($setek) || ($completeListSize == 0)) {
    OAIXMLError("noSetHierarchy", "This repository does not support sets");
  }
}

?>
